#pragma once

#include <stdio.h>
#include <setjmp.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
using namespace std;

#include "../skill.h"
#include "../output/image.h"
#include "../output/printtext.h"
#include "../globals.h"
#include "../timer.h"
#include "../unit.h"
#include "../input/keyboard.h"

#define NUM_FUNC        100
#define NUM_GLOBAL_VARS 100
#define NUM_LOCAL_VARS  200
#define NUM_BLOCK       100
#define ID_LEN          31
#define FUNC_CALLS      31
#define NUM_PARAMS      31
#define PROG_SIZE       10000
#define LOOP_NEST       31


enum tok_types {DELIMITER, IDENTIFIER, NUMBER, KEYWORD,
                TEMP, STRING, BLOCK};

/* сюда можно добавить дополнительные лексемы
   зарезервированных слов */
enum tokens {ARG_L, CHAR_L, INT_L, IF_L, ELSE_L, FOR_L, DO_L, WHILE_L,
             SWITCH_L, RETURN_L, EOL_L, FINISHED_L, END_L};

/* сюда можно добавить дополнительные двухсимвольные операторы,
   например, -> */
enum double_ops {LT=1, LE, GT, GE, EQ, NE};

/* Эти константы используются для вызова функции sntx_err()
   в случае синтаксической ошибки. При необходимости список
   констант можно расширить.
   ВНИМАНИЕ: константа SYNTAX используется тогда, когда
   интерпритатор не может квалифицировать ошибку.
*/
enum error_msg
     {SYNTAX, UNBAL_PARENS, NO_EXP, EQUALS_EXPECTED,
      NOT_VAR, PARAM_ERR, SEMI_EXPECTED,
      UNBAL_BRACES, FUNC_UNDEF, TYPE_EXPECTED,
      NEST_FUNC, RET_NOCALL, PAREN_EXPECTED,
      WHILE_EXPECTED, QUOTE_EXPECTED, NOT_TEMP,
      TOO_MANY_LVARS, DIV_BY_ZERO};
//-------------
bool InitLittleC(const char *fileName);
void StartLittleC();
void ExectFunct(const char *functName);
//-------------------------------------------------------------------------------------------
int print();
void prescan();
void decl_global(), call(), putback();
void decl_local(), local_push(struct var_type i);
void eval_exp(int *value), sntx_err(int error);
void exec_if(), find_eob(), exec_for();
void get_params(), get_args();
void exec_while(), func_push(int i), exec_do();
void assign_var(char *var_name, int value);
int load_program(char *p, const char *fname), find_var(char *s);
void interp_block(), func_ret();
int func_pop(), is_var(char *s), get_token();
char *find_func(const char *name);

extern char *prog;  /* текущее положение в исходном тексте программы */
extern char *p_buf;  /* указатель на начало буфера программы */
extern jmp_buf e_buf; /* содержит данные для longjmp() */
extern char token[80]; /* содержит строковое представление лексемы */
extern char token_type; /* содержит тип лексемы */
extern char tok; /* содержит внутренне представление лексемы */
extern int functos;  /* индекс вершины стека вызова функции */
extern int func_index; /* индекс в таблице функций */
extern int gvar_index; /* индекс в таблице глобальных переменных */
extern int lvartos; /* индекс в стеке локальных переменных */
extern int call_stack[NUM_FUNC];

int call_getche(), call_putch();
int call_puts(), getnum();

extern int ret_value; /* возвращаемое значение функции */

void eval_exp0(int *value);
void eval_exp(int *value);
void eval_exp1(int *value);
void eval_exp2(int *value);
void eval_exp3(int *value);
void eval_exp4(int *value);
void eval_exp5(int *value);
void atom(int *value);
void sntx_err(int error), putback();
void assign_var(char *var_name, int value);
int isdelim(char c), look_up(char *s), iswhite(char c);
int find_var(char *s), get_token();
int internal_func(char *s);
int is_var(char *s);
void call();
//---------------------------------
int call_getche();
int call_putch();
int get_token();
void sntx_err(int error), eval_exp(int *result);
void putback();
int getnum();
int ShowImageF();
int MoveImageF();
int DestroyImageF();
int ChangeSizeImageF();
int LoadImageF();
int CreateTimerF();
int AddExectFuncKeyF();
int GetImageXF();
int GetImageYF();
int ChangeWindowNameF();
int FullScreenF();
int PauseTimerF();
int DeleteTimerF();
int GetLastTimerF();
int GetCurrentTimerF();
int GetCurrentKeyF();
int ChangeFuncKeyF();
int DeleteFuncKeyF();
int ExitGameF();
int GetMouseXF();
int GetMouseYF();
int ChangeAllFontF();
int ChangeAllColorFontF();
int CreateTextF();
int DeleteTextF();
int HideTextF();
int GetLastGameTextF();
int MoveGameTextF();
int GetGameTextXF();
int GetGameTextYF();
int SetGameTextWHF();
int CreateUnitF();
int MoveUnitF();
int GetUnitXF();
int GetUnitYF();
int GetLastCreatedUnitF();
int SetUnitHPF();
int SetUnitMPF();
int SetUnitMaxHPF();
int SetUnitMaxMPF();
int AddUnitSkillF();
//--------------------------------------------------------------------------------
extern struct var_type global_vars[NUM_GLOBAL_VARS];
extern struct var_type local_var_stack[NUM_LOCAL_VARS];
extern struct func_type func_table[NUM_FUNC];
