#pragma once

#include "header.h"

/* Массив этих структур содержит информацию
   о глобальных переменных.
*/
struct var_type {
  char var_name[ID_LEN];
  int v_type;
  int value;
};

struct func_type {
  char func_name[ID_LEN];
  int ret_type;
  char *loc;  /* адрес точки входа в файл */
};

struct commands { /* таблица зарезервированных слов */
  const char command[20];
  char tok;
} const table[] = { /* В эту таблицу */
  {"if", IF_L}, /* команды должны быть введены на нижнем регистре. */
  {"else", ELSE_L},
  {"for", FOR_L},
  {"do", DO_L},
  {"while", WHILE_L},
  {"char", CHAR_L},
  {"int", INT_L},
  {"return", RETURN_L},
  {"end", END_L},
  {"", END_L}  /* конец таблицы */
};


struct intern_func_type {
  const char *f_name; /* имя функции */
  int (*p)();   /* указатель на функцию */
} const intern_func[] = {
  {"getche", call_getche},
  {"putch", call_putch},
  {"puts", call_puts},
  {"print", print},
  {"getnum", getnum},
  ///функции доп.
  {"showimage", ShowImageF},  ///(int, int)
  {"moveimage", MoveImageF},  ///(int, int, int)
  {"getimagex", GetImageXF}, /// (int)
  {"getimagey", GetImageYF}, /// (int)
  {"changesizeimage", ChangeSizeImageF}, ///(int, int, int)
  {"loadimage", LoadImageF}, ///(string)
  {"createtimer", CreateTimerF}, ///(bool, int, string)
  {"addexectfunckey", AddExectFuncKeyF}, ///(bool, int, string)
  {"changewindowname", ChangeWindowNameF}, ///(string)
  {"fullscreen", FullScreenF}, ///(bool)
  {"pausetimer", PauseTimerF}, ///(int, bool)
  {"deletetimer", DeleteTimerF}, ///(int)
  {"getlasttimer", GetLastTimerF}, ///()
  {"getcurrenttimer", GetCurrentTimerF}, ///()
  {"getcurrentkey", GetCurrentKeyF}, ///()
  {"changefunckey", ChangeFuncKeyF}, ///(int, string, string)
  {"deletefunckey", DeleteFuncKeyF}, ///(int, string)
  {"exitgame", ExitGameF}, ///()
  {"getmousex", GetMouseXF}, ///()
  {"getmousey", GetMouseYF}, ///()
  {"changeallfont", ChangeAllFontF}, ///(string, int)
  {"changeallcolorfont", ChangeAllColorFontF}, ///(int, int, int)
  {"createtext", CreateTextF}, ///(string, int, int, int, int)
  {"deletetext", DeleteTextF}, ///(int)
  {"hidetext", HideTextF}, ///(int, bool)
  {"getlastgametext", GetLastGameTextF}, ///()
  {"movegametext", MoveGameTextF}, ///(int, int, int)
  {"getgametextx", GetGameTextXF}, ///(int)
  {"getgametexty", GetGameTextYF}, ///(int)
  {"setgametextwh", SetGameTextWHF}, ///(int, int, int)
  {"createunit", CreateUnitF}, ///(int, int, int)
  {"moveunit", MoveUnitF}, ///(int, int, int)
  {"getunitx", GetUnitXF}, ///(int)
  {"getunity", GetUnitYF}, ///(int)
  {"getlastcreatedunit", GetLastCreatedUnitF}, ///()
  {"setunithp", SetUnitHPF}, ///(int, int)
  {"setunitmp", SetUnitMPF}, ///(int, int)
  {"setunitmaxhp", SetUnitMaxHPF}, ///(int, int)
  {"setunitmaxmp", SetUnitMaxMPF}, ///(int, int)
  {"addunitskill", AddUnitSkillF}, ///(int, int)
  {"", 0}  // этот список заканчивается нулем
}; /// {"",},

extern var_type  global_vars[NUM_GLOBAL_VARS];
extern var_type  local_var_stack[NUM_LOCAL_VARS];
extern func_type func_table[NUM_FUNC];
