#include "image.h"

///----------------------------------------
vector<textureImg> pictures;
vector<textureImg> systemPictures;
///----------------------------------------

textureImg::textureImg()
{
    pos.x=0; pos.y=0;
    xCenter=0; yCenter=0;
    gradus=0;
    show=false;
    path="";
}

textureImg::textureImg(const char* str)
{
  pos.x=0; pos.y=0;
  xCenter=0; yCenter=0;
  gradus=0;
  path=str;
  show=false;
  SetTexture(loadTexture(str));
}

void textureImg::SetPath(std::string str)
{path=str;}

void textureImg::SetShow(bool sh)
{show=sh;}

void textureImg::SetGradus(int gr)
{gradus=gr;}

void textureImg::SetCenter(int xc, int yc)
{xCenter=xc; yCenter=yc;}

void textureImg::SetCoords(int x1, int y1)
{pos.x=x1; pos.y=y1;}

void textureImg::SetSize(int w, int h)
{pos.w=w; pos.h=h;}

void textureImg::SetTexture(SDL_Texture *textr)
{
    texture=textr;
    SDL_QueryTexture(texture, NULL, NULL, &pos.w, &pos.h);
    SDL_RenderCopy(renderer, texture, NULL, &pos);
}

void textureImg::SetRect(SDL_Rect r)
{
  pos=r;
}

void textureImg::InitMe(const char* str)
{
  path=str;
  SetTexture(loadTexture(str));
}

//------------------------------------
void textureImg::Draw()
{
    if(show)
    {
        SDL_RenderCopy(renderer, texture, NULL, &pos);
    }
}
//------------------------------------

string textureImg::GetPath()
{return path;}

const char* textureImg::GetPathChar()
{const char* tmp=path.c_str();;
    return tmp;}

bool textureImg::GetShow()
{return show;}

SDL_Texture* textureImg::GetTexture()
{return texture;}

const SDL_Rect* textureImg::GetRect()
{
    const SDL_Rect* rect=&pos;
    return rect;
}

int textureImg::GetX()
{return pos.x;}

int textureImg::GetY()
{return pos.y;}

int textureImg::GetW()
{return pos.w;}

int textureImg::GetH()
{return pos.h;}
