#ifndef IMAGE_H
#define IMAGE_H

///-----------------------------------------
#include <SDL2/SDL.h>
#include <SDL2/SDL_main.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_ttf.h>

#include <string>
#include <map>
#include <vector>

using namespace std;
///-----------------------------------------
#include "../struct.h"
#include "../texture.h"
#include "../globals.h"
///-////////////////////////////////////////
class textureImg;
//==========================================
extern vector<textureImg> pictures;
extern vector<textureImg> systemPictures;
///-\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


class textureImg
{
private:
    SDL_Rect        pos;
    int             xCenter, yCenter;
    int             gradus;
    bool            show;
    string          path;
    SDL_Texture*    texture;
public:
    textureImg();
    textureImg(const char* str);

    void SetPath    (string str);
    void SetShow    (bool sh);
    void SetGradus  (int gr);
    void SetCenter  (int xc, int yc);
    void SetCoords  (int x1, int y1);
    void SetSize    (int w, int h);
    void SetTexture (SDL_Texture *textr);
    void SetRect    (SDL_Rect r);

    void Draw();
    void InitMe(const char* str);

    string          GetPath();
    const char*     GetPathChar();
    bool            GetShow();
    SDL_Texture*    GetTexture();
    const SDL_Rect* GetRect();
    int             GetX();
    int             GetY();
    int             GetW();
    int             GetH();
};







#endif
