#include "printtext.h"

///-----------------------------------------------------
SDL_Surface* fontSurface;
SDL_Color fColor;
TTF_Font* font;
SDL_Rect fontRect;
SDL_Texture* fontTexture;
int freeIdGameText=0; ///порследний свободный ид текста
int lastIdGameText=0; ///Ид последнего текста

map<int, gameText> gameTextMap;
map<int, gameText>::iterator gameTextMapIterator;
vector<gameText> sysTextMap;
///------------------------------------------------------

bool fontInit()
{
  TTF_Init();
  font = TTF_OpenFont("arial.ttf", 12);
  if(font==NULL){cout<<"Cant load arial.ttf font!"; return false;}
  fColor.r = 100;
  fColor.g = 100;
  fColor.b = 100;
  return true;
}

void ChangeFont(const char *ch, int sz)
{
  TTF_Font* fontTmp;
  fontTmp=TTF_OpenFont(ch, sz);
  if(fontTmp!=NULL)
  {
    font=fontTmp;
  }
  else{cout<<"Cant load "<<ch<<" font!";}
}

void ChangeColorFont(int r, int g, int b)
{
  fColor.r=r; fColor.g=g; fColor.b=b;
}

//Print the designated string at the specified coordinates
void PrintRenderText(string str, int x, int y, int w, int h)
{
  fontSurface = TTF_RenderUTF8_Solid(font, str.c_str(), fColor);
  fontRect.x = x;
  fontRect.y = y;
  fontRect.w = w;
  fontRect.h = h;
  fontTexture=SDL_CreateTextureFromSurface( renderer, fontSurface );
  SDL_RenderCopy(renderer, fontTexture, NULL, &fontRect);
}


gameText::gameText()
{
  hide=true;
  lastIdGameText=myId=freeIdGameText++;
}

void gameText::Draw()
{
  if(hide)return;

  surfF = TTF_RenderUTF8_Solid(font, text.c_str(), fColor);
  textureF=SDL_CreateTextureFromSurface(renderer, surfF);
  SDL_RenderCopy(renderer, textureF, NULL, &rectF);
}

void gameText::DeleteMe()
{
  hide=true;
  gameTextMap.erase(myId);
}

void gameText::SetText(string txt)
{
  text=txt;
}

void gameText::SetHide(bool h)
{
  hide=h;
}

void gameText::SetRect(SDL_Rect r)
{
  rectF=r;
}

void gameText::SetXY(int x, int y)
{
  rectF.x=x; rectF.y=y;
}

void gameText::SetWH(int w, int h)
{
  rectF.w=w; rectF.h=h;
}

void gameText::SetW(int w)
{
  rectF.w=w;
}


int gameText::GetX(){return rectF.x;}
int gameText::GetY(){return rectF.y;}
int gameText::GetLenText(){return text.length();}












