#ifndef PRINTTEXT_H
#define PRINTTEXT_H


///-----------------------------------------
#include <SDL2/SDL.h>
#include <SDL2/SDL_main.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_ttf.h>

#include <iostream>
#include <string>
#include <map>
#include <vector>

using namespace std;
///-----------------------------------------
#include "../globals.h"
///-////////////////////////////////////////
class gameText;
//==========================================
extern SDL_Surface* fontSurface;
extern SDL_Color fColor;
extern TTF_Font* font;
extern SDL_Rect fontRect;
extern int freeIdGameText; ///   
extern int lastIdGameText; ///  

extern map<int, gameText> gameTextMap;
extern map<int, gameText>::iterator gameTextMapIterator;
extern vector<gameText> sysTextMap;
///-\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\.
bool fontInit();
void PrintRenderText(string str, int x, int y, int w, int h);
void ChangeFont(const char *ch, int sz);
void ChangeColorFont(int r, int g, int b);



class gameText
{
private:
  SDL_Surface*  surfF;
  SDL_Texture*  textureF;
  SDL_Rect      rectF;
  bool          hide;
  string        text;

  int           myId;
public:
  gameText();

  void Draw();
  void DeleteMe();

  void SetText(string txt);
  void SetHide(bool h);
  void SetRect(SDL_Rect r);
  void SetXY(int x, int y);
  void SetWH(int w, int h);
  void SetW(int w);

  int GetX();
  int GetY();
  int GetLenText();
};









#endif

