#include "rect.h"


bool RectInRect(const SDL_Rect *rect, const SDL_Rect *region)
{
  point2D left_up, right_down;
  left_up.x = rect->x; left_up.y = rect->y;
  right_down.x = rect->w + rect->x; right_down.y = rect->h + rect->y;
  if(Point2DInRect(left_up, region) && Point2DInRect(right_down, region))
    return true;
  return false;
}


bool Point2DInRect(point2D point, const SDL_Rect *region)
{
  point2D true_coord;
  true_coord.x = region->x + region->w;
  true_coord.y = region->y + region->h;
  if((point.x >= region->x && point.x <= true_coord.x) && (point.y >= region->y && point.y <= true_coord.y))
    return true;
  return false;
}

bool XYInRect(int x, int y, const SDL_Rect *region)
{
  point2D true_coord;
  true_coord.x = region->x + region->w;
  true_coord.y = region->y + region->h;
  if((x >= region->x && x <= true_coord.x) && (y >= region->y && y <= true_coord.y))
    return true;
  return false;
}

int DistanceFromXYToXY(int x, int y, int x2, int y2, float &angle)
{
  int dist=0;
  dist=(x2-x)*(x2-x)+(y2-y)*(y2-y);
  dist=sqrt(dist);

  angle=atan2(y - y2, x - x2) / 3.14 * 180;
  angle = (angle < 0) ? angle + 360 : angle;
  ///cout<<"\ndist="<<dist<<"   angle="<<angle;
  return dist;
}

void GetAngleScrat(int x, int y, int x2, int y2, float &angle)
{
  int dist=0;
  dist=(x2-x)*(x2-x)+(y2-y)*(y2-y);
  dist=sqrt(dist);

  float sin_a = (y2-y)/dist;
  angle = asin(sin_a);
}

void XYFromDistance(int &x, int &y, int dist, float angle)
{
  cout<<"\nx="<<x<<"   y="<<y;
  angle = (angle > 90)? (360-angle)+360:angle;
  int y2;
  y2=sin(angle*57.3)*dist;
  y=y+y2;
  x=x+sqrt(dist*dist-y2*y2);
  cout<<"\nx="<<x<<"   y="<<y;
}



string ftoa(float num)
{
  stringstream str;
  str<<num;
  return str.str();
}


