#include "unit.h"


///-------------------------------------------------
map<int, UnitClass> units;
map<int, UnitClass>::iterator unitsIterator;
vector<UnitTemplate> templUnits;
int unitFreeNumber=0;
int unitLastNumber=0;
vector<UnitClass*> choosenUnits;
UnitClass *navodkaUnit=NULL;
///-------------------------------------------------

UnitClass::UnitClass()
{
  rect.x=0; rect.y=0; rect.w=15; rect.h=15;
  orderPoint.x=0; orderPoint.y=0;
  livesPoints=100.;
  livesPointsMax=100.;
  manaPoints=0.;
  manaPointsMax=0.;
  speedBasic=10;
  speedMax=20;
  speed=0;
  action=NONE;
  showSkill=false;
}

void UnitClass::InitMe()
{
  videlModel.InitMe("levels/level1/img/select.bmp");
  navodkaModel.InitMe("levels/level1/img/videl.bmp");
  videlModel.SetRect(rect);
  navodkaModel.SetRect(rect);
  lastFreeSkillPlace=0;
}

void UnitClass::SetShablon(int id)
{
  myIdShablon=id;
  model.SetPath(templUnits[id].picModel);
  model.SetTexture(loadTexture(templUnits[id].picModel.c_str()));
  speedBasic=templUnits[id].speedBasic;
  speedMax=templUnits[id].speedMax;
  livesPoints=livesPointsMax=templUnits[id].livesPoints;
  manaPoints=manaPointsMax=templUnits[id].manaPoints;
  model.SetRect(rect);
  model.SetShow(true);
  videlModel.SetRect(rect); navodkaModel.SetRect(rect);
  lastFreeSkillPlace=0;
}

void UnitClass::SetCord(int x, int y)
{
  rect.x=x; rect.y=y; model.SetCoords(x, y); videlModel.SetRect(rect); navodkaModel.SetRect(rect);
}

void UnitClass::SetOrder(int x, int y){orderPoint.x=x; orderPoint.y=y;}
void UnitClass::SetLives(float liv){livesPoints=liv;}
void UnitClass::SetMaxLives(float liv){livesPointsMax=liv;}
void UnitClass::SetMana(float man){manaPoints=man;}
void UnitClass::SetMaxMana(float man){manaPointsMax=man;}
void UnitClass::SetSpeedBasic(int spd){speedBasic=spd;}
void UnitClass::SetSpeedMax(int spd){speedMax=spd;}
void UnitClass::SetSpeed(int spd){speed=spd;}

void UnitClass::AddSkill(int id)
{
  SkillMagic tmpSkill(id);
  tmpSkill.SetXY(XYspells[lastFreeSkillPlace++]);
  skill.push_back(tmpSkill);
}

void UnitClass::Draw()
{
  model.Draw();
  videlModel.Draw();
  navodkaModel.Draw();
}

void UnitClass::OrderUnit(int x, int y)
{
  ///cout<<"\nOrder to:"<<x<<","<<y;
  orderPoint.x=x; orderPoint.y=y;
  action=WALKING;
}

void UnitClass::Tick()
{
  switch(action)
  {
    case NONE:
    break;
    case WALKING:
      float angle;
      int dist=DistanceFromXYToXY(rect.x, rect.y, orderPoint.x, orderPoint.y, angle);
      if(dist<=10+templUnits[myIdShablon].radiusPath)
      {action=NONE; speed=0; orderPoint.x=orderPoint.y=0;}
      else
      {
        //GetAngleScrat(rect.x, rect.y, orderPoint.x, orderPoint.y, angle);
        //XYFromDistance(rect.x, rect.y, 4, angle);
        //if(dist<=DistanceFromXYToXY(rect.x, rect.y, orderPoint.x, orderPoint.y, angle))
        //{
          rect.x=orderPoint.x;
          rect.y=orderPoint.y;
          //cout<<"\nend";
        //}
        model.SetRect(rect);
        videlModel.SetRect(rect); navodkaModel.SetRect(rect);
      }
    break;
  }
}

void UnitClass::ShowVidel(bool sh)
{
  videlModel.SetShow(sh);
}

void UnitClass::ShowNavodka(bool sh)
{
  navodkaModel.SetShow(sh);
}

int UnitClass::GetX(){return rect.x;}
int UnitClass::GetY(){return rect.y;}
point2D UnitClass::GetOrder(){return orderPoint;}
float UnitClass::GetLives(){return livesPoints;}
float UnitClass::GetMaxLives(){return livesPointsMax;}
float UnitClass::GetMana(){return manaPoints;}
float UnitClass::GetMaxMana(){return manaPointsMax;}
int UnitClass::GetSpeedBasic(){return speedBasic;}
int UnitClass::GetSpeedMax(){return speedMax;}
int UnitClass::GetSpeed(){return speed;}
const SDL_Rect* UnitClass::GetRect()
{
  const SDL_Rect* rectM=&rect;
  return rectM;
}


