#ifndef UNIT_H
#define UNIT_H

///#include "header.h"


///-----------------------------------------
#include <map>
#include <vector>

using namespace std;
///-----------------------------------------
#include "output/image.h"
#include "skill.h"
#include "rect.h"
///-////////////////////////////////////////
struct UnitTemplate;
class UnitClass;
//==========================================
extern  map<int, UnitClass>            units;
extern  map<int, UnitClass>::iterator  unitsIterator;
extern  vector<UnitTemplate>           templUnits;
extern  int                            unitFreeNumber;
extern  int                            unitLastNumber;
extern  vector<UnitClass*>             choosenUnits;
extern  UnitClass                     *navodkaUnit;
///-\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\.
enum{NONE, WALKING, SLEEPING, ATTACKINGUNIT, ATTACKINGGROUND, HOLDINGATTACK};
///---^ 

class UnitClass
{
private:
  point2D       orderPoint;
  float         livesPoints;
  float         livesPointsMax;
  float         manaPoints;
  float         manaPointsMax;
  int           speedBasic;     ///  
  int           speedMax;       /// 
  int           speed;
  point2D       centerUnit;     ///  
  textureImg    model;  ///  
  SDL_Rect      rect;
  int           myIdShablon; ///     
  short         action; ///   
  textureImg    videlModel;
  textureImg    navodkaModel;

  bool          showSkill;
  int           lastFreeSkillPlace;
public:
  vector<SkillMagic> skill;

  UnitClass();

  void SetShablon     (int id);

  void SetCord        (int x, int y);
  void SetOrder       (int x, int y);
  void SetLives       (float liv);
  void SetMaxLives    (float liv);
  void SetMana        (float man);
  void SetMaxMana     (float man);
  void SetSpeedBasic  (int spd);
  void SetSpeedMax    (int spd);
  void SetSpeed       (int spd);
  void AddSkill       (int id);

  void InitMe         ();             /// 
  void Draw           ();
  void OrderUnit      (int x, int y);
  void Tick           ();             ///   
  void ShowVidel      (bool sh);      /// 
  void ShowNavodka    (bool sh);      /// 

  int               GetX();
  int               GetY();
  point2D           GetOrder();
  float             GetLives();
  float             GetMaxLives();
  float             GetMana();
  float             GetMaxMana();
  int               GetSpeedBasic();
  int               GetSpeedMax();
  int               GetSpeed();
  const SDL_Rect*   GetRect();
};

struct UnitTemplate
{
  float         livesPoints;    /// 
  float         manaPoints;     /// 
  string        picModel;       ///  
  int           radiusPath;     ///   
  int           speedBasic;     ///  
  int           speedMax;       /// 
  bool          canRun;         /// ?
  unsigned      templateID;     ///  
};







#endif
